
IFrameFactory = {
	Registry = { },
}


function IFrameFactory:Register(addOnName, frameName, frameInterface)
	if (self.Registry[addOnName] == nil) then
		self.Registry[addOnName] = { }
	end
	
	local Info = {
		Index = 0,
		Interface = frameInterface,
		List = { },
	}
	self.Registry[addOnName][frameName] = Info
end

function IFrameFactory:Create(addOnName, frameName)
	local Info = self.Registry[addOnName][frameName]
	
	local frameObject = table.remove(Info.List)
	if (frameObject == nil) then
		local frameName = string.format("IFrameFactory__"..addOnName..frameName.."__%05d__", Info.Index)
		Info.Index = Info.Index + 1
		frameObject = Info.Interface:Create(frameName)
		frameObject:ClearAllPoints()
	end
	
	frameObject:SetParent(UIParent)
	frameObject:Show()
	
	return frameObject
end

function IFrameFactory:Destroy(addOnName, frameName, frameObject)
	local Info = self.Registry[addOnName][frameName]
	
	frameObject = Info.Interface:Destroy(frameObject)
	
	frameObject:ClearAllPoints()
	frameObject:SetParent(UIParent)
	frameObject:Hide()
	
	table.insert(Info.List, frameObject)
end
