
spellBook = { }


function spellBook:onLoad()
	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	this:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
	this:RegisterEvent("SPELLS_CHANGED")
	this:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	
	self.playerSpells = { }
	self.petSpells = { }
end

local sbDB = { }
function sbLoad()
	local spellID = 1
	local name, suffix = GetSpellName(spellID, BOOKTYPE_SPELL)
	local start, duration, enabled = GetSpellCooldown(spellID, BOOKTYPE_SPELL)
	local texture = GetSpellTexture(spellID, BOOKTYPE_SPELL)
	
	while (name) do
		if (sbDB[spellID] == nil) then
			sbDB[spellID] = { }
		end
		local si = sbDB[spellID]
		si.name, si.suffix = GetSpellName(spellID, BOOKTYPE_SPELL)
		si.start, si.duration, si.enabled = GetSpellCooldown(spellID, BOOKTYPE_SPELL)
		si.texture = GetSpellTexture(spellID, BOOKTYPE_SPELL)
		
		spellID = spellID + 1
		name = si.name
	end
end

function sbSort()
	local currentTime = GetTime()
	
	table.sort(sbDB,
		function(l,r)			
			local leftTime = l.duration - ( currentTime - l.start)
			local rightTime = r.duration - ( currentTime - r.start)
			
			return leftTime < rightTime
		end
	)
end

function spellBook:onEvent()
	self.playerSpells = { }
	self.petSpells = { }
	
	local spellID = 1
	local spellName = GetSpellName(spellID, BOOKTYPE_SPELL)
	
	while (spellName) do
		local spellInfo = { }
			
		spellInfo.spellID = spellID
		spellInfo.spellType = BOOKTYPE_SPELL
		spellInfo.spellName, spellInfo.spellSuffix = GetSpellName(spellInfo.spellID, spellInfo.spellType)
		spellInfo.spellStart, spellInfo.spellDuration, spellInfo.spellEnabled = GetSpellCooldown(spellInfo.spellID, spellInfo.spellType)
		spellInfo.spellTexture = GetSpellTexture(spellInfo.spellID, spellInfo.spellType)
		
		table.insert(self.playerSpells, spellInfo)
		
		spellID = spellID + 1
		spellName = spellInfo.spellName
	end
	
	local spellID = 1
	local spellName = GetSpellName(spellID, BOOKTYPE_PET)
	
	while (spellName) do
		local spellInfo = { }
			
		spellInfo.spellID = spellID
		spellInfo.spellType = BOOKTYPE_PET
		spellInfo.spellName, spellInfo.spellSuffix = GetSpellName(spellInfo.spellID, spellInfo.spellType)
		spellInfo.spellStart, spellInfo.spellDuration = GetSpellCooldown(spellInfo.spellID, spellInfo.spellType)
		spellInfo.spellTexture = GetSpellTexture(spellInfo.spellID, spellInfo.spellType)
		
		table.insert(self.petSpells, spellInfo)
		
		spellID = spellID + 1
		spellName = spellInfo.spellName
	end
end

function spellBook:getID(spellName)
	for _, spellInfo in self.playerSpells do
		if (spellInfo.spellName == spellName) then
			return spellInfo.spellID
		end
	end
	
	return nil
end
